Package net.sf.saxon.option.jdom2

## Class JDOM2NodeWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper
  - - net.sf.saxon.option.jdom2.JDOM2NodeWrapper

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `SiblingCountingNode`, `VirtualNode`, `org.xml.sax.Locator`

      public class JDOM2NodeWrapper
      extends AbstractNodeWrapper
      implements SiblingCountingNode

  A node in the XML parse tree representing an XML element, character content, or attribute.

  This is the implementation of the NodeInfo interface used as a wrapper for JDOM2 nodes.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `index` |
    `protected NamespaceMap` | `inScopeNamespaces` |
    `protected java.lang.Object` | `node` |
    `protected short` | `nodeKind` |

    - ### Fields inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `treeInfo`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `int` | `getColumnNumber()` | Get column number
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `int` | `getLineNumber()` | Get line number
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `int` | `getNodeKind()` | Return the type of node.
    `NodeInfo` | `getParent()` | Get the NodeInfo object representing the parent of this node
    `java.lang.String` | `getPrefix()` | Get the prefix part of the name of this node.
    `NodeInfo` | `getRoot()` | Get the root node - always a document node with this tree implementation
    `int` | `getSiblingPosition()` | Get the index position of this node among its siblings (starting from 0) In the case of a text node that maps to several adjacent siblings in the JDOM, the numbering actually refers to the position of the underlying JDOM nodes; thus the sibling position for the text node is that of the first JDOM node to which it relates, and the numbering of subsequent XPath nodes is not necessarily consecutive.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `JDOM2DocumentWrapper` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `java.lang.Object` | `getUnderlyingNode()` | Get the underlying JDOM2 node, to implement the VirtualNode interface.
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `isId()` | Determine whether this node has the is-id property
    `boolean` | `isIdref()` | Determine whether this node has the is-idref property
    `protected AxisIterator` | `iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iterator over the attributes of this element node.
    `protected AxisIterator` | `iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iterator over the children of this node.
    `protected AxisIterator` | `iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean includeSelf)` | Return an iterator over the descendants of this node.
    `protected AxisIterator` | `iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean forwards)` | Return an iterator over the siblings of this node.
    `protected static JDOM2NodeWrapper` | `makeWrapper​(java.lang.Object node, JDOM2DocumentWrapper docWrapper)` | Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.
    `protected static JDOM2NodeWrapper` | `makeWrapper​(java.lang.Object node, JDOM2DocumentWrapper docWrapper, JDOM2NodeWrapper parent, int index)` | Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.

    - ### Methods inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `atomize, equals, getBaseURI, getFingerprint, getNamePool, getRealNode, getStringValue, getSystemId, hasFingerprint, hashCode, iterateAxis, iterateAxis, saveLocation, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, head, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.s9api.Location

      `saveLocation`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, attributes, children, children, copy, equals, getBaseURI, getConfiguration, getFingerprint, getGenre, getPublicId, getSchemaType, getStringValue, getSystemId, hasFingerprint, hashCode, isNilled, isSameNodeInfo, isStreamed, iterateAxis, iterateAxis, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty, setSystemId`

- - ### Field Detail

    - #### node

          protected java.lang.Object node

    - #### nodeKind

          protected short nodeKind

    - #### index

          protected int index

    - #### inScopeNamespaces

          protected NamespaceMap inScopeNamespaces

  - ### Method Detail

    - #### makeWrapper

          protected static JDOM2NodeWrapper makeWrapper​(java.lang.Object node,
                                                        JDOM2DocumentWrapper docWrapper)

      Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The JDOM node
        `docWrapper` - The wrapper for the Document containing this node
      Returns:
        The new wrapper for the supplied node

    - #### makeWrapper

          protected static JDOM2NodeWrapper makeWrapper​(java.lang.Object node,
                                                        JDOM2DocumentWrapper docWrapper,
                                                        JDOM2NodeWrapper parent,
                                                        int index)

      Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The JDOM node
        `docWrapper` - The wrapper for the Document containing this node
        `parent` - The wrapper for the parent of the JDOM node
        `index` - The position of this node relative to its siblings
      Returns:
        The new wrapper for the supplied node

    - #### getUnderlyingNode

          public java.lang.Object getUnderlyingNode()

      Get the underlying JDOM2 node, to implement the VirtualNode interface. If this wrapper node represents a list of adjacent text nodes, then the first of the text nodes is returned.
      Specified by:
        `getUnderlyingNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getTreeInfo

          public JDOM2DocumentWrapper getTreeInfo()

      Description copied from interface: `NodeInfo`
      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Overrides:
        `getTreeInfo` in class `AbstractNodeWrapper`
      Returns:
        the TreeInfo

    - #### getNodeKind

          public int getNodeKind()

      Return the type of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### compareOrder

          public int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getLineNumber

          public int getLineNumber()

      Description copied from class: `AbstractNodeWrapper`
      Get line number
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Overrides:
        `getLineNumber` in class `AbstractNodeWrapper`
      Returns:
        the line number of the node in its original source document; or -1 if not available. Always returns -1 in this implementation.

    - #### getColumnNumber

          public int getColumnNumber()

      Description copied from class: `AbstractNodeWrapper`
      Get column number
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Overrides:
        `getColumnNumber` in class `AbstractNodeWrapper`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "".

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix part of the name of this node. This is the name before the ":" if any. (Note, this method isn't required as part of the NodeInfo interface.)
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        the prefix part of the name. For an unnamed node, return an empty string.

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for a node with an empty prefix, return an empty string.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Overrides:
        `getDisplayName` in class `AbstractNodeWrapper`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public NodeInfo getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        the parent of this node; null if this node has no parent

    - #### getSiblingPosition

          public int getSiblingPosition()

      Get the index position of this node among its siblings (starting from 0) In the case of a text node that maps to several adjacent siblings in the JDOM, the numbering actually refers to the position of the underlying JDOM nodes; thus the sibling position for the text node is that of the first JDOM node to which it relates, and the numbering of subsequent XPath nodes is not necessarily consecutive.
      Specified by:
        `getSiblingPosition` in interface `SiblingCountingNode`
      Returns:
        0 for the first child, 1 for the second child, etc.

    - #### iterateAttributes

          protected AxisIterator iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the attributes of this element node. This method is only called after checking that the node is an element.
      Specified by:
        `iterateAttributes` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the attribute nodes. The order of the result, although arbitrary, must be consistent with document order.

    - #### iterateChildren

          protected AxisIterator iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the children of this node. This method is only called after checking that the node is an element or document.
      Specified by:
        `iterateChildren` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the child nodes, in document order.

    - #### iterateSiblings

          protected AxisIterator iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                 boolean forwards)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the siblings of this node. This method is only called after checking that the node is an element, text, comment, or PI node.
      Specified by:
        `iterateSiblings` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned siblings must satisfy
        `forwards` - true for following siblings, false for preceding siblings
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### iterateDescendants

          protected AxisIterator iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                    boolean includeSelf)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the descendants of this node. This method is only called after checking that the node is an element or document node.
      Overrides:
        `iterateDescendants` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned descendants must satisfy
        `includeSelf` - true if this node is to be included in the result
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Overrides:
        `getAttributeValue` in class `AbstractNodeWrapper`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        8.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node - always a document node with this tree implementation
      Specified by:
        `getRoot` in interface `NodeInfo`
      Overrides:
        `getRoot` in class `AbstractNodeWrapper`
      Returns:
        the NodeInfo representing the containing document

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.

      Note: the result is equivalent to `getEnumeration(AxisInfo.CHILD, AnyNodeTest.getInstance()).hasNext()`

      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `AbstractNodeWrapper`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a Buffer to contain a string that uniquely identifies this node, across all documents

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `AbstractNodeWrapper`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of namespace binding objects representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. If the uri part is "", then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to null.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Overrides:
        `getAllNamespaces` in class `AbstractNodeWrapper`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Determine whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute